#ifndef EFL_GENERATED_ECORE_AUDIO_OUT_HH
#define EFL_GENERATED_ECORE_AUDIO_OUT_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_audio_out.eo.h"
}

#include "ecore_audio.eo.hh"

struct ecore_audio_out
      : ecore_audio
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_out(Eo* eo)
      : ecore_audio(eo)
   {}

   ecore_audio_out(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_out(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_out(ecore_audio_out const& other)
      : ecore_audio(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_out() {}

   /// @brief Attach an input to an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   Eina_Bool input_attach(Eo * input) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(input));
      return _tmp_ret;
   }

   /// @brief Detach an input from an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   Eina_Bool input_detach(Eo * input) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(input));
      return _tmp_ret;
   }

   /// @brief Returns the list of all attached inputs
   ///
   /// @since 1.8
   ///
   Eina_List * inputs_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OBJ_OUT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_AUDIO_OBJ_OUT_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Eina_Bool ecore_audio_out_input_attach_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eo * input)
{
   return static_cast<T*>(self->this_)->input_attach(input);
}

template <typename T>
Eina_Bool ecore_audio_out_input_detach_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eo * input)
{
   return static_cast<T*>(self->this_)->input_detach(input);
}

template <typename T>
Eina_List * ecore_audio_out_inputs_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->inputs_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_out >
{
   template <typename T>
   struct type
   {
      virtual Eina_Bool input_attach(Eo * input)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_out_input_attach(input));
         return _tmp_ret;
      }

      virtual Eina_Bool input_detach(Eo * input)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_out_input_detach(input));
         return _tmp_ret;
      }

      virtual Eina_List * inputs_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_out_inputs_get());
         return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_out >
{
   static const int value = 3;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_out>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::ecore_audio_out_input_attach_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_attach);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::ecore_audio_out_input_detach_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_detach);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::ecore_audio_out_inputs_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_inputs_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_out >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::ecore_audio_out>
{
   template <typename T>
   struct type
   {
      operator ::ecore_audio_out() const
      {
         return ::ecore_audio_out(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

      Eina_Bool input_attach(Eo * input)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(input));
         return _tmp_ret;
      }

      Eina_Bool input_detach(Eo * input)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(input));
         return _tmp_ret;
      }

      Eina_List * inputs_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
         return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_out>)
{
   return (ECORE_AUDIO_OBJ_OUT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_OUT_HH

